<template>
  <div>
    <div class="text-center" v-if="isLoading">
      <div>
        <b-spinner class="m-5" variant="primary" style="width: 3rem; height: 3rem;"></b-spinner>
        <div class="d-flex align-items-center">
          <strong>Loading...</strong>
        </div>
      </div>
    </div>


    <div v-else>
      <div class="b-container" style="margin-bottom: 1rem; margin-top: 1rem">
        <b-row align-h="between">
          <b-col cols="4">Welcome to {{ pageX | getTableNameByFilter }} table</b-col>
          <b-col cols="4" v-if="!isRetrieving && isUserLogged">
            <b-button variant="outline-primary" @click="addRow">Add new row</b-button>
          </b-col>
          <b-col cols="4" v-if="isRetrieving">
            <div class="container">
              <div class="row">
                <div class="col-lg-4">
                  <b-button variant="outline-success" @click="goBack"
                            v-b-tooltip title="To return the precedent page">Go back
                  </b-button>
                </div>
              </div>
            </div>
          </b-col>
        </b-row>
      </div>

      <b-table striped hover :items="matrix" :fields="fields">
        <template v-slot:cell()="{ value, item, field: { key }}">
          <div v-if="!retrieveFields.includes(key)">
            <template v-if="item.action === actions.READING">{{ value }}</template>
            <b-form-input v-else v-model="item[key]" :disabled="item.action === actions.SAVING"/>
          </div>
          <b-button v-if="retrieveFields.includes(key) && item.action === actions.CREATING"
                    @click="retrieveElements(item.backupDbId, key)">retrieve
          </b-button>
          <div v-if="retrieveFields.includes(key) &&
          item.action === actions.READING">
            <template>{{ value }}</template>
          </div>
        </template>


        <template v-slot:cell(selected)="{ item: {backupDbId, selected }}">
          <b-form-radio
              v-if="isGetOne"
              v-model="retrieveElementsByCheckBox"
              name="some-radios"
              :value="backupDbId"
              :disabled="!isUserLogged"></b-form-radio>
          <b-form-checkbox
              v-else
              :id="backupDbId"
              v-model="retrieveElementsByCheckBox"
              name="checkbox-1"
              :value="backupDbId"
              :disabled="!isUserLogged"
              unchecked-value="not_accepted"
          ></b-form-checkbox>
        </template>

        <template v-slot:cell(number)="{ value, item, field: { key }}">
          <b-container fluid>
            <b-form-input v-model="item[key]" :disabled="!isUserLogged"/>
          </b-container>
        </template>

        <template v-slot:cell(edit)="{ item: { backupDbId, action }}">
          <div class="container">
            <div class="row">
              <div class="col-md"  v-if="action === actions.READING && pageX !== 'companyClient'">
                <b-button class="btn-block" variant="outline-primary" @click="editRow(backupDbId, false)">
                  Edit
                </b-button>
              </div>
              <div class="col-md" v-if="action === actions.EDITING">
                <b-button class="btn-block" variant="outline-success" @click="save(backupDbId)">Save
                </b-button>
                </div>
              <div class="col-md" v-if="action === actions.CREATING">
              <b-button class="btn-block" variant="outline-success" @click="create(backupDbId)">Create
              </b-button>
              </div>
              <div class="col-md" v-if="action === actions.EDITING">
              <b-button class="btn-block" variant="outline-secondary" @click="reset(backupDbId)">Reset
              </b-button>
              </div>
              <div class="col-md"  v-if="action === actions.SAVING">
              <b-button class="btn-block" variant="primary">
                <b-spinner small type="grow"></b-spinner>
                Loading...
              </b-button>
              </div>
            </div>
          </div>
        </template>


        <template v-slot:cell(delete)="{ item: { backupDbId, action }}">
          <b-button class="btn-block" variant="outline-danger" @click="deleteRow(backupDbId)"
                    v-if="action !== actions.DELETING && action !== actions.SAVING">Delete
          </b-button>
          <b-button class="btn-block" variant="primary" disabled v-if="action === actions.DELETING">
            <b-spinner small type="grow"></b-spinner>
            Loading...
          </b-button>
        </template>
      </b-table>
    </div>

    <AlertModal ref="modalComponent"/>
  </div>
</template>

<script>
/**
 * The file contains the core of mini-ERP table.
 * This core can be used like library:
 * It is possible to add new schema table adding the schema on fieldsConfiguration variable.
 * In addition for every switch statement it is necessary to specify the action to be done for this specific table.
 * It has been got this approach in order don't repeat the code but only to set the flags.
 *
 * The core is able to understand witch table is working.
 * In order to do it, the core uses the path that is saved on pageX.
 */
import { uuid } from 'vue-uuid';

import Vuex from 'vuex';

import AlertModal from '../components/modals/AlertModal';
import Store from '../stores/Store'

export default {
  name: 'table',
  components: {
    AlertModal
  },
  store: Store,
  data() {
    //The action that the user can be
    return {
      actions: {
        CREATING: 0,
        EDITING: 1,
        DELETING: 2,
        READING: 3,
        SAVING: 4,
        SELECT: 5,
      },
      fields: [],
      /*
        Contains a backup of specific row in order to do a revert of data.
        In others terms when the uses edits a row, the old row is saved in this variable so when the users does a revert
        the row is restored using this variable.
       */
      localMatrix: [],
      //Contains the data that the mini-ERP shows.
      matrix: [],
      // Is used in order to show a spin loop to indicate the user that the page is loading.
      isLoading: true,
      isUserLogged: false,
      pageX: this.$route.name,

      isRetrieving: false,
      isGetOne: false,
      retrieveElementsByCheckBox: [],
      //This variable contains all the items that has to retrieve from the others table.
      retrieveFields: [],

      unsubscribe: null
    }
  },
  computed: {
    rows() {
      return this.matrix.length
    }
  },
  filters: {
    /**
     * It used in order to show the right information on the top of the page.
     *
     * @param value
     * @returns {string|*}
     */
    getTableNameByFilter: function (value) {
      switch (value) {
        case ('companyClient'): {
          return 'transaction company → client';
        }
      }
      return value;
    }
  },
  watch: {
    /**
     * It used in order to understand if the user has changed the table. When the user changes the table, the path changes
     * so this watch is able to understand it and (the watch) launches the init method for initializing the new table.
     */
    $route() {
      this.isLoading = true;
      this.pageX = this.$route.name;
      this.init();
    }
  },
  methods: {
    ...Vuex.mapGetters([
      'getUserByStore'
    ]),
    ...Vuex.mapMutations([
      'destroyRetrieve',
      'setCountVisitByStore',
      'setIsGetOneByStore',
      'setUserByStoreIsEditing',
      'setRetrieveByStore'
    ]),
    /**
     * The method has the work to add or remove the actions or fields. The method is launched the others when the
     * somethings is changed like in the store.
     */
    addOrRemoveAction() {
      this.setVariableIsRetrieving();
      if (this.isRetrieving === true) {
        this.fields = fieldsConfiguration[this.pageX];
        switch (this.pageX) {
          case ('product'): {
            this.fields = this.fields.concat([{
              key: 'number',
              label: 'Number',
              sortable: true
            }]);
          }
        }
        this.fields = this.fields.concat([{
          key: 'selected',
          label: 'Selected',
          sortable: true
        }]);
      } else {
        this.fields = fieldsConfiguration[this.pageX];
        this.fields = this.fields.concat(fieldsAction);
        if (!this.getUserByStore().isLogged) {
          this.fields = fieldsConfiguration[this.pageX];
        } else {
          this.fields = fieldsConfiguration[this.pageX];
          this.fields = this.fields.concat(fieldsAction);
        }
      }
    },
    /**
     * The method adds a new row to the table. Each table has necessity to have particulars items.
     */
    addRow() {
      let id = uuid.v1();
      switch (this.pageX) {
        case('client'): {
          this.matrix.push({
            action: this.actions.CREATING,
            backupDbId: id,
            id: id,
            name: null,
            country: null,
            address: null
          });
          break;
        }
        case('company'): {
          this.matrix.push({
            action: this.actions.CREATING,
            backupDbId: id,
            id: id,
            name: null,
            balance: null,
            country: null
          });
          break;
        }
        case('companyClient'): {
          this.matrix.push({
            action: this.actions.CREATING,
            backupDbId: id,
            id: id,
            companyId: null,
            clientId: null,
            employeeId: null,
            productIds: null
          });
          break;
        }
        case('employee'): {
          this.matrix.push({
            action: this.actions.CREATING,
            backupDbId: id,
            id: id,
            name: null,
            birthday: 'yyyy-mm-dd',
            country: null,
            firstDayInTheCompany: 'yyyy-mm-dd'
          });
          break;
        }
        case('product'): {
          this.matrix.push({
            action: this.actions.CREATING,
            backupDbId: id,
            id: id,
            name: null,
            price: 0,
            tax: 0,
            stock: 0
          });
          break;
        }
        case('provider'): {
          this.matrix.push({
            action: this.actions.CREATING,
            backupDbId: id,
            id: id,
            name: null,
            address: null,
            country: null
          });
          break;
        }
      }
      this.setUserByStoreIsEditing(true);
    },
    /**
     * The method is able to check if the row is right in order after to create the packet and sent it to the server.
     * If the server will replay with a success the method transform the row from creating/editing to seeing.
     * Otherwise it will show an alert (The phrase of alert for the moment it is a general alert).
     *
     * Only for transaction the success returns (of the server) is a bit different, because it necessary to set the
     * right ids on the matrix.
     *
     * @param backupDbId the id row of the table.
     */
    create(backupDbId) {
      for (let i = 0; i < this.matrix.length; i++) {
        if (this.matrix[i].backupDbId === backupDbId) {
          this.matrix[i]['action'] = this.actions.SAVING;
          break;
        }
      }
      let row = this.createRow(backupDbId);
      row = (JSON.parse(JSON.stringify((row))));
      delete row['action'];
      delete row['backupDbId'];
      if (!this.verifyRowX(row)) {
        this.rollbackCreationOrEditRow(backupDbId, true);
        return;
      }
      this.$http.post('resource/' + this.pageX, row).then(
          () => {
            for (let i = 0; i < this.matrix.length; i++) {
              if (this.matrix[i].backupDbId === backupDbId) {
                this.matrix[i]['action'] = this.actions.READING;
                switch (this.pageX) {
                  case ('companyClient'): {
                    this.matrix[i]['clientId'] = row.clientId;
                    this.matrix[i]['companyId'] = row.companyId;
                    this.matrix[i]['employeeId'] = row.employeeId;
                  }
                }
                break;
              }
            }
            this.setUserByStoreIsEditing(false);
          },
          () => {
            this.rollbackCreationOrEditRow(backupDbId, true);
            this.$refs.modalComponent.showModal();
          }
      );
    },
    /**
     * The method is launched when the user wishes to create a new row on the server. This method has the work to create
     * the row to send to the server. For all the tables (except the transaction tables) the method gets the information
     * from the matrix variable. Instead for the transaction table, the method gets the information from the store.
     *
     * @param backupDbId
     * @returns {{}|*}
     */
    createRow(backupDbId) {
      switch (this.pageX) {
        case('client'):
        case('company'): {
          return this.matrix.find((matrix) => matrix.backupDbId === backupDbId);
        }
        case ('companyClient'): {
          let row = {};
          for (let i = 0; i < this.retrieveFields.length; i++) {
            let index = this.getUserByStore().retrieveElements.findIndex((row) =>
                row.nameOfTable === this.pageX &&
                row.rowTableId === backupDbId &&
                row.elementOfTable === this.retrieveFields[i]
            );
            if (index >= 0) {
              if (this.retrieveFields[i] === 'productIds') {
                row['numbers'] = [];
                for (let i = 0; i < this.getUserByStore().retrieveElements[index].numbers.length; i++) {
                  row['numbers'].push({
                    id: this.getUserByStore().retrieveElements[index].numbers[i].id,
                    number: parseInt(this.getUserByStore().retrieveElements[index].numbers[i].number)
                  });
                }
              } else {
                row[this.retrieveFields[i]] = [];
                row[this.retrieveFields[i]] = JSON.parse(JSON.stringify(this.getUserByStore().retrieveElements[index].retrievedIds));
              }
            }
          }
          row['id'] = this.matrix.find((matrix) => matrix.backupDbId === backupDbId).id;
          return row;
        }
        case('employee'):
        case('product'):
        case('provider'): {
          return this.matrix.find((matrix) => matrix.backupDbId === backupDbId);
        }
      }
    },
    editRow(backupDbId, isNewRow) {
      this.edit = this.edit !== backupDbId ? backupDbId : null;
      for (let i = 0; i < this.matrix.length; i++) {
        if (this.matrix[i].backupDbId === backupDbId) {
          this.localMatrix.push(JSON.parse(JSON.stringify((this.matrix[i]))));
          this.matrix[i]['action'] = isNewRow ? this.actions.CREATING : this.actions.EDITING;
          break;
        }
      }
      this.setUserByStoreIsEditing(true);
    },
    deleteRow(backupDbId) {
      let id = null;
      let index = 0;
      let action = null;
      for (let i = 0; i < this.matrix.length; i++) {
        if (this.matrix[i].backupDbId === backupDbId) {
          if (this.matrix[i]['action'] === this.actions.EDITING) {
            action = this.actions.EDITING;
            id = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId).id;
          } else {
            id = this.matrix[i].id;
            action = this.actions.READING;
          }
          this.matrix[i]['action'] = this.actions.DELETING;
          index = i;
          break;
        }
      }
      this.$http.delete('resource/' + this.pageX + '/' + id).then(
          () => {
            this.matrix = this.matrix.filter((e) => e.backupDbId !== backupDbId);
            this.localMatrix = this.matrix.filter((e) => e.backupDbId !== backupDbId);
          },
          () => {
            this.matrix[index]['action'] = action;
            this.$refs.modalComponent.showModal();
          });
    },
    goBack() {
      let numbers = [];
      switch (this.pageX) {
        case ('product'): {
          this.matrix.forEach((row) => {
            let tmp = this.retrieveElementsByCheckBox.find((id) => id === row['id']);
            if (tmp !== undefined) {
              numbers.push({
                id: row['id'],
                number: row['number']
              })
            }
          });
        }
      }
      this.setRetrieveByStore({
        isRetrieving: false,
        nameOfTable: this.getUserByStore().nameOfTable,
        rowTableId: this.getUserByStore().rowTableId,
        elementOfTable: this.getUserByStore().elementOfTable,
        retrievedIds: this.retrieveElementsByCheckBox,
        numbers: numbers,
        retrievingByTable: null
      });
      this.retrieveElementsByCheckBox = [];
      this.$router.go(-1);
    },
    /**
     * The method initialize the table, putting the right field on retrieveFields variable if the table has to retrieve
     * some elements. After it does a GET in order to get the information of the table from the server.
     * At the end, it shows the information.
     */
    init() {
      // Chose the right retrieve fields
      switch (this.pageX) {
        case('companyClient'): {
          this.retrieveFields = ['companyId', 'clientId', 'employeeId', 'productIds'];
          break;
        }
      }

      // Launch a subscription in order to change the state of the table if the store changes from the nav bar or others
      // component.
      this.unsubscribe = this.$store.subscribe(() => {
        this.isUserLogged = this.getUserByStore().isLogged;
        this.setVariableIsRetrieving();

        //If the user is no more logged, the user cannot to edit or create the row.
        if (this.getUserByStore().isLogged !== true) {
          this.matrix = this.matrix.filter((item) => item.action !== this.actions.CREATING);
          let ids = this.matrix.filter((item) => item.action === this.actions.EDITING);
          ids.forEach((id) => {
            this.reset(id.backupDbId);
          });
        }
        this.addOrRemoveAction();
      });
      this.isUserLogged = this.getUserByStore().isLogged;
      this.setVariableIsRetrieving();

      if (this.isRetrieving === true) {
        this.isGetOne = this.getUserByStore().isGetOne;
        this.setCountVisitByStore(this.getUserByStore().countVisit + 1);
      } else {
        if (this.getUserByStore().countVisit === 1 && this.pageX !== this.getUserByStore().nameOfTable) {
          this.destroyRetrieve();
        } else if (this.getUserByStore().countVisit === 1 && this.pageX === this.getUserByStore().nameOfTable) {
          this.matrix = JSON.parse(JSON.stringify(this.getUserByStore().matrix));
          this.addOrRemoveAction();
          this.isLoading = false;
          return;
        }
      }
      this.$http.get('resource/' + this.pageX).then((response) => {
            this.addOrRemoveAction();
            this.isLoading = false;
            for (let i = 0; i < response.data.length; i++) {
              response.data[i]['backupDbId'] = response.data[i].id;
              response.data[i]['action'] = this.actions.READING;
            }
            this.matrix = response.data
          },
          () => {
            this.fields = fieldsConfiguration[this.pageX];
            this.isLoading = false;
            this.$refs.modalComponent.showModal('It is not possible to retrieve the table');
          }
      );
    },
    save(backupDbId) {
      for (let i = 0; i < this.matrix.length; i++) {
        if (this.matrix[i].backupDbId === backupDbId) {
          this.matrix[i]['action'] = this.actions.SAVING;
          break;
        }
      }
      let row = this.matrix.find((matrix) => matrix.backupDbId === backupDbId);
      if (!this.verifyRowX(row)) {
        this.rollbackCreationOrEditRow(backupDbId, false);
        return;
      }
      this.$http.put('resource/' + this.pageX, row).then(
          () => {
            this.localMatrix = this.localMatrix.filter((e) => e.backupDbId !== backupDbId);
            for (let i = 0; i < this.matrix.length; i++) {
              if (this.matrix[i].backupDbId === backupDbId) {
                this.matrix[i]['action'] = this.actions.READING;
                break;
              }
            }
          },
          () => {
            for (let i = 0; i < this.matrix.length; i++) {
              if (this.matrix[i].backupDbId === backupDbId) {
                this.matrix[i]['action'] = this.actions.EDITING;
                break;
              }
            }
            this.$refs.modalComponent.showModal();
          }
      );
    },
    reset(backupDbId) {
      switch (this.pageX) {
        case('client'): {
          for (let i = 0; i < this.matrix.length; i++) {
            if (this.matrix[i].backupDbId === backupDbId) {
              let tmp = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId);
              this.matrix[i].id = tmp.id;
              this.matrix[i].name = tmp.name;
              this.matrix[i].address = tmp.address;
              this.matrix[i].country = tmp.country;
              this.matrix[i]['action'] = this.actions.READING
              break;
            }
          }
          break;
        }
        case('company'): {
          for (let i = 0; i < this.matrix.length; i++) {
            if (this.matrix[i].backupDbId === backupDbId) {
              let tmp = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId);
              this.matrix[i].id = tmp.id;
              this.matrix[i].name = tmp.name;
              this.matrix[i].balance = tmp.balance;
              this.matrix[i].country = tmp.country;
              this.matrix[i]['action'] = this.actions.READING
              break;
            }
          }
          break;
        }
        case('companyClient'): {
          for (let i = 0; i < this.matrix.length; i++) {
            if (this.matrix[i].backupDbId === backupDbId) {
              let tmp = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId);
              this.matrix[i].id = tmp.id;
              this.matrix[i].companyId = tmp.companyId;
              this.matrix[i].clientId = tmp.clientId;
              this.matrix[i].employeeid = tmp.employeeid;
              this.matrix[i]['action'] = this.actions.READING
              break;
            }
          }
          break;
        }
        case('employee'): {
          for (let i = 0; i < this.matrix.length; i++) {
            if (this.matrix[i].backupDbId === backupDbId) {
              let tmp = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId);
              this.matrix[i].id = tmp.id;
              this.matrix[i].name = tmp.name;
              this.matrix[i].birthday = tmp.birthday;
              this.matrix[i].country = tmp.country;
              this.matrix[i].firstDayInTheCompany = tmp.firstDayInTheCompany;
              this.matrix[i]['action'] = this.actions.READING
              break;
            }
          }
          break;
        }
        case('product'): {
          for (let i = 0; i < this.matrix.length; i++) {
            if (this.matrix[i].backupDbId === backupDbId) {
              let tmp = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId);
              this.matrix[i].id = tmp.id;
              this.matrix[i].name = tmp.name;
              this.matrix[i].price = tmp.price;
              this.matrix[i].tax = tmp.tax;
              this.matrix[i].stock = tmp.stock;
              this.matrix[i]['action'] = this.actions.READING
              break;
            }
          }
          break;
        }
        case('provider'): {
          for (let i = 0; i < this.matrix.length; i++) {
            if (this.matrix[i].backupDbId === backupDbId) {
              let tmp = this.localMatrix.find((matrix) => matrix.backupDbId === backupDbId);
              this.matrix[i].id = tmp.id;
              this.matrix[i].name = tmp.name;
              this.matrix[i].address = tmp.address;
              this.matrix[i].country = tmp.country;
              this.matrix[i]['action'] = this.actions.READING
              break;
            }
          }
          break;
        }
      }
      this.localMatrix = this.localMatrix.filter((e) => e.backupDbId !== backupDbId);
    },
    retrieveElements(backupDbId, key) {
      switch (this.pageX) {
        case('companyClient'): {
          switch (key) {
            case (this.retrieveFields[0]): {
              this.setRetrieveByStore({
                countVisit: 0,
                matrix: this.matrix,
                isGetOne: true,
                isRetrieving: true,
                nameOfTable: this.pageX,
                rowTableId: backupDbId,
                elementOfTable: key,
                retrievedIds: [],
                retrievingByTable: 'company'
              });
              this.$router.push('company');
              break;
            }
            case (this.retrieveFields[1]): {
              this.setRetrieveByStore({
                countVisit: 0,
                matrix: this.matrix,
                isGetOne: true,
                isRetrieving: true,
                nameOfTable: this.pageX,
                rowTableId: backupDbId,
                elementOfTable: key,
                retrievedIds: [],
                retrievingByTable: 'client'
              });
              this.$router.push('client');
              break;
            }
            case (this.retrieveFields[2]): {
              this.setRetrieveByStore({
                countVisit: 0,
                matrix: this.matrix,
                isGetOne: true,
                isRetrieving: true,
                nameOfTable: this.pageX,
                rowTableId: backupDbId,
                elementOfTable: key,
                retrievedIds: [],
                retrievingByTable: 'employee'
              });
              this.$router.push('employee');
              break;
            }
            case (this.retrieveFields[3]): {
              this.setRetrieveByStore({
                countVisit: 0,
                matrix: this.matrix,
                isGetOne: false,
                isRetrieving: true,
                nameOfTable: this.pageX,
                rowTableId: backupDbId,
                elementOfTable: key,
                retrievedIds: [],
                retrievingByTable: 'product'
              });
              this.$router.push('product');
              break;
            }
          }
        }
      }
    },
    rollbackCreationOrEditRow(backupDbId, isCreating) {
      for (let i = 0; i < this.matrix.length; i++) {
        if (this.matrix[i].backupDbId === backupDbId) {
          if (isCreating === true) {
            this.matrix[i]['action'] = this.actions.CREATING;
          } else {
            this.matrix[i]['action'] = this.actions.EDITING;
          }
          break;
        }
      }
    },
    setVariableIsRetrieving() {
      this.isRetrieving = this.getUserByStore().isRetrieving === true && this.getUserByStore().retrievingByTable === this.pageX;
    },
    verificationDate(dateString) {
      // First check for the pattern Ex: 2021-10-27
      if (!/^\d{1,4}-\d{1,2}-\d{1,2}$/.test(dateString))
        return false;

      // Parse the date parts to integers
      const parts = dateString.split('-');
      const day = parseInt(parts[2], 10);
      const month = parseInt(parts[1], 10);
      const year = parseInt(parts[0], 10);

      // Check the ranges of month and year
      if (year < 1000 || year > 3000 || month === 0 || month > 12)
        return false;

      const monthLength = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

      // Adjust for leap years
      if (year % 400 === 0 || (year % 100 !== 0 && year % 4 === 0))
        monthLength[1] = 29;

      // Check the range of the day
      return day > 0 && day <= monthLength[month - 1];
    },
    verifyClientRow(row) {
      if (row['id'] === null || row['id'].length < 1 || row['id'].length > 36) {
        this.$refs.modalComponent.showModal('Please insert a right id (min 1 and max 36 char)');
        return false;
      }
      if (row['name'] === null || row['name'].length < 1 || row['name'].length > 100) {
        this.$refs.modalComponent.showModal('Please insert a right name (min 1 and max 100 char)');
        return false;
      }
      if (row['address'] === null || row['address'].length < 1 || row['address'].length > 255) {
        this.$refs.modalComponent.showModal('Please insert a right address (min 1 and max 255 char)');
        return false;
      }
      if (row['country'] === null || row['country'].length < 1 || row['country'].length > 255) {
        this.$refs.modalComponent.showModal('Please insert a right country (min 1 and max 255 char)');
        return false;
      }
      return true;
    },
    verifyCompanyRow(row) {
      if (row['id'] === null || row['id'].length < 1 || row['id'].length > 36) {
        this.$refs.modalComponent.showModal('Please insert a right id (min 1 and max 36 char)');
        return false;
      }
      if (row['name'] === null || row['name'].length < 1 || row['name'].length > 100) {
        this.$refs.modalComponent.showModal('Please insert a right name (min 1 and max 100 char)');
        return false;
      }

      let [isSuccess, returnValue] = this.verifyFloatNumber(row['balance'], 0, 100000);
      if (isSuccess === false) {
        this.$refs.modalComponent.showModal('Please insert a right balance (equal or greater than zero and less than 100000)');
        return false;
      }
      row['balance'] = returnValue;

      return true;
    },
    verifyCompanyClientRow(row) {
      if (row['id'] === null || row['id'].length < 1 || row['id'].length > 36) {
        this.$refs.modalComponent.showModal('Please insert a right id (min 1 and max 36 char)');
        return false;
      }
      if (row['clientId'] === undefined || row['clientId'] === null || row['clientId'].length < 1 || row['clientId'].length > 36) {
        this.$refs.modalComponent.showModal('Please select a right client id (min 1 and max 36 char)');
        return false;
      }
      if (row['companyId'] === undefined || row['companyId'] === null || row['companyId'].length < 1 || row['companyId'].length > 36) {
        this.$refs.modalComponent.showModal('Please select a  company id (min 1 and max 36 char)');
        return false;
      }
      if (row['employeeId'] === undefined || row['employeeId'] === null || row['employeeId'].length < 1 || row['employeeId'].length > 36) {
        this.$refs.modalComponent.showModal('Please select a right employee id (min 1 and max 36 char)');
        return false;
      }

      if (!row['numbers'] || !Array.isArray(row['numbers'])) {
        this.$refs.modalComponent.showModal('Please select at least a product id');
        return false;
      }
      for (let i = 0; i < row['numbers'].length; i++) {
        if (row['numbers'].length < 0) {
          this.$refs.modalComponent.showModal('Please select at least a product id');
          return false
        }
      }
      return true;
    },
    verifyEmployeeRow(row) {
      if (row['id'] === null || row['id'].length < 1 || row['id'].length > 36) {
        this.$refs.modalComponent.showModal('Please insert a right id (min 1 and max 36 char)');
        return false;
      }
      if (row['name'] === null || row['name'].length < 1 || row['name'].length > 100) {
        this.$refs.modalComponent.showModal('Please insert a right name (min 1 and max 100 char)');
        return false;
      }
      if (row['birthday'] === null || !this.verificationDate(row['birthday'])) {
        this.$refs.modalComponent.showModal('Please insert a right birthday (yyyy-mm-dd)');
        return false;
      }
      if (row['country'] === null || row['country'].length < 1 || row['country'].length > 255) {
        this.$refs.modalComponent.showModal('Please insert a right country (min 1 and max 255 char)');
        return false;
      }
      if (row['firstDayInTheCompany'] === null || !this.verificationDate(row['firstDayInTheCompany'])) {
        this.$refs.modalComponent.showModal('Please insert a right firstDayInTheCompany (yyyy-mm-dd)');
        return false;
      }
      return true;
    },
    verifyProductRow(row) {
      if (row['id'] === null || row['id'].length < 1 || row['id'].length > 36) {
        this.$refs.modalComponent.showModal('Please insert a right id (min 1 and max 36 char)');
        return false;
      }
      if (row['name'] === null || row['name'].length < 1 || row['name'].length > 100) {
        this.$refs.modalComponent.showModal('Please insert a right name (min 1 and max 100 char)');
        return false;
      }

      let [isSuccess, returnValue] = this.verifyFloatNumber(row['price'], 0, 100000);
      if (isSuccess === false) {
        this.$refs.modalComponent.showModal('Please insert a right price (equal or greater than zero and less than 100000)');
        return false;
      }
      row['price'] = returnValue;

      [isSuccess, returnValue] = this.verifyFloatNumber(row['tax'], 0, 100000);
      if (isSuccess === false) {
        this.$refs.modalComponent.showModal('Please insert a right tax (equal or greater than zero and less than 100000)');
        return false;
      }
      row['tax'] = returnValue;

      if (isNaN(parseInt(row['stock']))) {
        this.$refs.modalComponent.showModal('Please insert a right stock (equal or greater than 0 and less than 100000)');
        return false;
      }
      row['stock'] = parseInt(row['stock']);
      if (row['stock'] < 0 || row['stock'] > 100000) {
        this.$refs.modalComponent.showModal('Please insert a right stock (equal or greater than 0 and less than 100000)');
        return false
      }
      if (isSuccess === false) {
        this.$refs.modalComponent.showModal('Please insert a right stock (equal or greater than 0 and less than 100000)');
        return false;
      }
      return true;
    },
    verifyProviderRow(row){
      if (row['id'] === null || row['id'].length < 1 || row['id'].length > 36) {
        this.$refs.modalComponent.showModal('Please insert a right id (min 1 and max 36 char)');
        return false;
      }
      if (row['name'] === null || row['name'].length < 1 || row['name'].length > 100) {
        this.$refs.modalComponent.showModal('Please insert a right name (min 1 and max 100 char)');
        return false;
      }
      if (row['address'] === null || row['address'].length < 1 || row['address'].length > 255) {
        this.$refs.modalComponent.showModal('Please insert a right address (min 1 and max 255 char)');
        return false;
      }
      if (row['country'] === null || row['country'].length < 1 || row['country'].length > 255) {
        this.$refs.modalComponent.showModal('Please insert a right country (min 1 and max 255 char)');
        return false;
      }
      return true;
    },
    /**
     * The method does two items:
     *  - Verifies if the input is a float number and
     * it stays between the maximum and minimum given to the method.
     * - Convert the string to float returning it.
     *
     * @param valueToVerify string to verify
     * @param min the number to verify must be greater than the min
     * @param max the number to verify must be lesser than the max
     * @returns {[boolean, String]|[boolean, null]} return a vector of two parameters:
     * - A bool in order to say if the number is right or no.
     * - The string converted in float if the number is right otherwise null.
     */
    verifyFloatNumber(valueToVerify, min, max) {
      valueToVerify = parseFloat(valueToVerify);
      if (isNaN(valueToVerify)) {
        return [false, null];
      }
      if (valueToVerify < min || valueToVerify > max) {
        return [false, null];
      }
      return [true, valueToVerify];
    },
    /**
     * This methods is a wrapper in order to chose the right verifier (it's a wrapper method).
     *
     * @param row the row of table to check
     * @returns {boolean} returns what the verifier returns
     */
    verifyRowX(row) {
      switch (this.pageX) {
        case('client'): {
          return this.verifyClientRow(row);
        }
        case('company'): {
          return this.verifyCompanyRow(row);
        }
        case('companyClient'): {
          return this.verifyCompanyClientRow(row);
        }
        case('employee'): {
          return this.verifyEmployeeRow(row);
        }
        case('product'): {
          return this.verifyProductRow(row);
        }
        case('provider'): {
          return this.verifyProviderRow(row);
        }
      }
    }
  },
  beforeDestroy() {
    this.unsubscribe();
  },
  mounted() {
    this.init();
  },
}
/**
 * The JSON describes the actions that the user can do. This json has dynamically updated in relation that the user can do.
 * The default actions are put in this point.
 */
const fieldsAction = [
  {
    key: 'edit',
    label: 'Edit',
    sortable: false
  }, {
    key: 'delete',
    label: 'Delete',
    sortable: false
  }
];

/**
 * The variable describes all tables that the mini-ERP core can manage.
 */
const fieldsConfiguration =
    {
      client: [
        {
          key: 'id',
          label: 'Id',
          sortable: true
        }, {
          key: 'name',
          label: 'Name',
          sortable: true
        }, {
          key: 'address',
          label: 'Address',
          sortable: true
        }, {
          key: 'country',
          label: 'Country',
          sortable: true
        }],
      company: [
        {
          key: 'id',
          label: 'Id',
          sortable: true
        }, {
          key: 'name',
          label: 'Name',
          sortable: true
        }, {
          key: 'balance',
          label: 'Balance',
          sortable: true
        }, {
          key: 'country',
          label: 'Country',
          sortable: true
        }],
      companyClient: [
        {
          key: 'id',
          label: 'Id',
          sortable: true
        }, {
          key: 'clientId',
          label: 'Client id',
          sortable: true
        }, {
          key: 'companyId',
          label: 'Company id',
          sortable: true
        }, {
          key: 'employeeId',
          label: 'Employee id',
          sortable: true
        }, {
          key: 'productIds',
          label: 'Product ids',
          sortable: true
        }],
      employee: [
        {
          key: 'id',
          label: 'Id',
          sortable: true
        }, {
          key: 'name',
          label: 'Name',
          sortable: true
        }, {
          key: 'birthday',
          label: 'Birthday',
          sortable: true
        }, {
          key: 'country',
          label: 'Country',
          sortable: true
        }, {
          key: 'firstDayInTheCompany',
          label: 'First day in the company',
          sortable: true
        }],
      product: [
        {
          key: 'id',
          label: 'Id',
          sortable: true
        }, {
          key: 'name',
          label: 'Name',
          sortable: true
        }, {
          key: 'price',
          label: 'Price',
          sortable: true
        }, {
          key: 'tax',
          label: 'Tax',
          sortable: true
        }, {
          key: 'stock',
          label: 'Stock',
          sortable: true
        }],
      provider: [
        {
          key: 'id',
          label: 'Id',
          sortable: true
        }, {
          key: 'name',
          label: 'Name',
          sortable: true
        }, {
          key: 'address',
          label: 'Address',
          sortable: true
        }, {
          key: 'country',
          label: 'Country',
          sortable: true
        }]
    };


</script>
<style>
.table.b-table > thead > tr > th {
  background-color: #beb9b9;
  position: sticky;
  position: -webkit-sticky;
  top: 0;
  z-index: 2;
}
</style>
